'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _LazilyLoader = require('./LazilyLoader');

var _LazilyLoader2 = _interopRequireDefault(_LazilyLoader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {
	return undefined;
};
var BundlesSet = new Set([]);

/**
 * @class
 * @author gcy[of1518]
 * @date 2017.06
 * @description
 */
var BundleContainer = (_temp = _class = function (_Component) {
	_inherits(BundleContainer, _Component);

	function BundleContainer() {
		_classCallCheck(this, BundleContainer);

		var _this = _possibleConstructorReturn(this, (BundleContainer.__proto__ || Object.getPrototypeOf(BundleContainer)).apply(this, arguments));

		_this.state = {};
		return _this;
	}

	_createClass(BundleContainer, [{
		key: 'render',
		value: function render() {
			var _ref = this.props || {},
			    bundles = _ref.bundles;

			var bundlesNode = bundles.map(function (v, k) {
				var _ref2 = v || {},
				    name = _ref2.name,
				    path = _ref2.path,
				    title = _ref2.title,
				    source = _ref2.source;

				return _react2.default.createElement(_reactRouterDom.Route, { path: path, title: title, strict: true, exact: false, render: function render(props) {
						return _react2.default.createElement(_LazilyLoader2.default, { key: '@bundle_' + name, name: name, source: source, isBundle: true });
					} });
			});

			return bundlesNode ? _react2.default.createElement(
				_reactRouterDom.Switch,
				null,
				bundlesNode
			) : null;
		}
	}]);

	return BundleContainer;
}(_react.Component), _class.defaultprops = {
	bundles: []
}, _temp);
exports.default = BundleContainer;