'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _LazilyLoader = require('./LazilyLoader');

var _LazilyLoader2 = _interopRequireDefault(_LazilyLoader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class
 * @author gcy[of1518]
 * @date 2017.06
 * @description
 */
var ChunkContainer = (_temp = _class = function (_Component) {
	_inherits(ChunkContainer, _Component);

	function ChunkContainer() {
		_classCallCheck(this, ChunkContainer);

		var _this = _possibleConstructorReturn(this, (ChunkContainer.__proto__ || Object.getPrototypeOf(ChunkContainer)).apply(this, arguments));

		_this.RouteContainer = function (routes) {
			var self = _this;
			if (Array.isArray(routes) && routes.length > 0) {
				return _react2.default.createElement(
					_reactRouterDom.Switch,
					null,
					routes.map(function (v, k) {
						var _ref = v || {},
						    children = _ref.routes;

						if (Array.isArray(children) && children.length > 0) {
							return _react2.default.createElement(_reactRouterDom.Route, { key: v.name, path: v.path || '/', render: function render(props) {
									return _react2.default.createElement(
										_LazilyLoader2.default,
										_extends({ key: '@chunk_' + v.name }, v, props, { isChunk: true }),
										self.RouteContainer(children)
									);
								}
							});
						} else {
							return _react2.default.createElement(_reactRouterDom.Route, _extends({ key: v.name, path: v.path || '/' }, v, { render: function render(props) {
									return _react2.default.createElement(_LazilyLoader2.default, _extends({ key: '@chunk_' + v.name }, v, props, { isChunk: true }));
								} }));
						}
					})
				);
			} else {
				return null;
			}
		};

		return _this;
	}

	_createClass(ChunkContainer, [{
		key: 'render',
		value: function render() {
			var _ref2 = this.props || {},
			    entries = _ref2.entries;

			var ContainerNode = this.RouteContainer(entries || []);
			return ContainerNode;
		}
	}]);

	return ChunkContainer;
}(_react.Component), _class.defaultProps = {
	entries: []
}, _temp);
exports.default = ChunkContainer;