"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _reactRouter = require("react-router");

var _reactRouterDom = require("react-router-dom");

var _history = require("history");

var _QMDecorator = require("QMDecorator");

var _QMDecorator2 = _interopRequireDefault(_QMDecorator);

var _container = require("./container");

var _container2 = _interopRequireDefault(_container);

var _ChunkLoader = require("./ChunkLoader");

var _ChunkLoader2 = _interopRequireDefault(_ChunkLoader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var history = (0, _history.createHashHistory)();

/**
 * @class 
 * @author gcy[of1518]
 * @date 2017.06
 * @description 控制台项目入口（仅本地开发环境）
 */
var APP = (_temp = _class = function (_Component) {
	_inherits(APP, _Component);

	function APP() {
		_classCallCheck(this, APP);

		var _this = _possibleConstructorReturn(this, (APP.__proto__ || Object.getPrototypeOf(APP)).apply(this, arguments));

		_this.state = {};
		return _this;
	}

	_createClass(APP, [{
		key: "render",
		value: function render() {
			var _ref = this.props || {},
			    bundles = _ref.bundles;

			return _react2.default.createElement(
				_reactRouter.Router,
				{ history: history },
				_react2.default.createElement(
					_QMDecorator2.default,
					null,
					_react2.default.createElement(
						_reactRouterDom.Switch,
						null,
						_react2.default.createElement(BundleLoader, { bundles: bundles || [] })
					)
				)
			);
		}
	}]);

	return APP;
}(_react.Component), _class.defaultProps = {
	bundles: []
}, _temp);


(0, _reactDom.render)(_react2.default.createElement(APP, null), document.getElementById("react-content"));